<template>
  <div class="q-pa-md q-gutter-sm" v-if="dataSet?.soy_propietario">
    <q-btn
      v-if="dataSet.eventos_estado_id === 1"
      class="btn-fixed-width"
      color="blue"
      unelevated
      label="Abrir Inscripción"
      icon="launch"
      @click.prevent="cambiarEstado(2)"
    />
    <q-btn
      v-if="dataSet.eventos_estado_id === 2"
      class="btn-fixed-width"
      color="amber"
      unelevated
      label="Cerrar Inscripción"
      icon="flight_takeoff"
      @click.prevent="cambiarEstado(3)"
    />
    <q-btn
      v-if="dataSet.eventos_estado_id === 3"
      class="btn-fixed-width"
      color="amber"
      unelevated
      label="ReAbrir Inscripción"
      icon="launch"
      @click.prevent="cambiarEstado(2)"
    />
    <q-btn
      v-if="dataSet.eventos_estado_id === 3"
      class="btn-fixed-width"
      color="blue"
      unelevated
      label="Finalizar Evento"
      icon="close_fullscreen"
      @click.prevent="cambiarEstado(4)"
    />
    <q-btn
      v-if="!dataSet.borrado && $isCan('eventos.baja')"
      class="btn-fixed-width"
      color="red"
      unelevated
      label="Eliminar Evento"
      @click.prevent="eliminarEvento()"
      icon="delete"
    />

    <q-btn
      v-if="dataSet.curso_uuid"
      class="btn-fixed-width"
      color="purple"
      unelevated
      :to="'/formacion/experiencias/detalle/' + dataSet.curso_uuid"
      label="Ir a AMS"
    />

    <Loading :showing="loading" text="Procesando Solicitud ..." />
  </div>
</template>

<script lang="ts">
import { defineComponent, ref, toRef } from 'vue';
import { useQuasar } from 'quasar';
import { AxiosResponse } from 'axios';
import { api } from 'src/boot/axios/index';
import Loading from 'src/components/Loading.vue';

export default defineComponent({
  name: 'BotonEstadoPartial',
  components: { Loading },

  props: {
    evento: {
      type: Object,
      required: true,
    },
  },

  setup(props) {
    const loading = ref(false);
    const $q = useQuasar();

    const dataSet = toRef(props, 'evento');
    /*
    watch(
      () => props.evento,
      (evento) => {
        dataSet.value = evento;
      }
    );

    onMounted(() => {
      console.log('sss');
    });*/

    function getEventos() {
      api
        .get('/api/eventos/eventos/' + dataSet.value.uuid)
        .then((response: AxiosResponse) => {
          dataSet.value = response.data;
          loading.value = false;
        });
    }

    function cambiarEstado(nuevoEstado: number) {
      $q.dialog({
        title: 'Cambio de estado',
        color: 'red',
        message:
          'Esta seguro que quiere cambiar el estado del evento, esta accion no podra ser revertida',
        cancel: true,
        persistent: true,
      })
        .onOk(() => {
          loading.value = true;
          api
            .put('/api/eventos/estado', {
              uuid: dataSet.value.uuid,
              estado: nuevoEstado,
            })
            .then(() => {
              getEventos();
            });
        })
        .onCancel(() => {
          $q.notify({
            message: 'Accion cancelada',
            color: 'blue',
            position: 'top',
          });
          loading.value = false;
        });
    }

    function eliminarEvento() {
      loading.value = true;

      $q.dialog({
        title: 'ELIMINAR',
        color: 'red',
        message:
          'Usted esta queriendo eliminar el evento<br/> <h4 class="bg-red">ESTA ACCION NO PODRA SER REVERTIDA</h4>',
        cancel: true,
        html: true,
        persistent: true,
      })
        .onOk(() => {
          api
            .delete('/api/eventos/eventos', {
              data: {
                uuid: dataSet.value.uuid,
              },
            })
            .then(() => {
              getEventos();
            })
            .finally(() => {
              loading.value = false;
            });
        })
        .onCancel(() => {
          $q.notify({
            message: 'Accion cancelada',
            color: 'blue',
            position: 'top',
          });
          loading.value = false;
        });
    }

    return {
      loading,
      cambiarEstado,
      eliminarEvento,
      dataSet,
    };
  },
});
</script>
